#!/usr/local/bin/perl
#
# High Score summary for this month
# Copyright 1999 Jari Karjala <jka@iki.fi> - no warranties!
#
# The above copyright must be included in any derived work.
#

# Absolute path to StarMines install directory in web server
$DOC_ROOT = $ENV{"DOCUMENT_ROOT"};
$GAMEPATH = "$DOC_ROOT/smj";
#$GAMEPATH = ".";

$LOGPREFIX= "StarMinesLog";
$limit	= 25;

print "Content-type: text/html\n\n";

$method = $ENV{"REQUEST_METHOD"};
if ($method eq "" ) { ## command line  testing
	$method = $ARGV[0];
	$temp = $ARGV[1];
}
elsif ($method eq "GET") {
    $temp = $ENV{"QUERY_STRING"};
}
else {
	## Real CGI
	read(STDIN, $temp, $ENV{"CONTENT_LENGTH"});
}

($arg,$min,$hour,$mday,$arg_mon,$arg_year,$wday,$yday,$isdst) = localtime(time);
$arg_mon++;
$arg_year+=1900;

@pairs=split(/&/,$temp);
foreach $item(@pairs) {
  ($key,$content)=split (/=/,$item,2);
  $key =~ s/[^A-Za-z0-9_]/_/ge;
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  ## Assign variable
  eval "\$arg_$key = '$content'";
  print STDERR "Eval '$key' error: $@\n" if ($@);
  if ( $content eq "on" ) {
	eval "\$$key = 'true'";
  }
}

$log = "$GAMEPATH/$LOGPREFIX"."-$arg_year-$arg_mon.txt";
$today = sprintf("%02d.%02d.%02d", $arg_year, $arg_mon, $mday);

open(FILE, "$log") or die "Cannot open $log";

$gets = 0;
$posts = 0;
while(<FILE>) {
  chop;
  ($date, $time, $op, $addr, $name, $score, $info) = split(/\t/,$_);
  if ($op eq "POST") {
      if ($score > $summary{$name}) {
          $summary{$name} = $score;
          $summaryInfo{$name} = $info;
          $summaryDate{$name} = $date;
      }
      $posts++;
  }
}
close(FILE);

@mons = ( "Zero", "January", "February", "March", "April", "May", "June",
        "July", "August", "September", "October", "November", "December" );

  print "<html><head><title>StarMines for Java - $mons[$arg_mon] top $limit</title></head>";
  print '<body text="yellow" link="white" vlink="yellow" bgcolor="black">';
  print "<center><h2>StarMines for Java - $mons[$arg_mon] top $limit</h2>\n";
  print '<table border=1 cellspacing="1" cellpadding="1" width="400" >';
  print '<tr><td width="10%" align=center>#</td>';
  print '<td width="35%" align=center>Player</td>';
  print '<td width="25%" align=center>Score</td>';
  print '<td width="30%" align=center>When</td>';
  print "</tr>\n";

  $i = 1;
  foreach $key (sort { $summary{$b} <=> $summary{$a} } keys %summary) {
	$fScore = $summary{$key};
	$fName = $key;
	$fInfo = $summaryInfo{$key};
	$date = $summaryDate{$key};
	($level, $zoids) = split(/ /,$fInfo,2);
    if ($level eq "") {
        $level = "&nbsp;";
        $zoids = "&nbsp;";
    }
    if ($i<=$limit) {
        print "<tr><td align=center>".($i).".</td>";
        print "<td align=center>&nbsp;$fName</td>";
        print "<td align=center>$fScore</td>";
#        print "<td align=center>$level</td>";
#        print "<td align=center>$zoids</td>";
        print "<td align=center>$date</td>";
        print "</tr>\n";
        $i++;
    }
  }
  print '</table>';
  print '<p><a href="smjscores.pl?format=html">[All Time Hall of Fame]</a>';

  print '<p><a href="StarMines.html">[Back to Game]</a>';

  print "</center></body>\n</html>\n";
