#!c:/Perl/bin/Perl.exe
#!/usr/local/bin/perl
#
# High Score server as a CGI script for use with StarMines for Java
# Copyright 1999 Jari Karjala <jka@iki.fi> - no warranties!
#
# The above copyright must be included in any derived work.
#

# Absolute local file system path to StarMines install directory in web server
$DOC_ROOT = $ENV{"DOCUMENT_ROOT"};
$GAMEPATH = "$DOC_ROOT/smj";

$SCORES   = "StarMines.scores";
$LOGPREFIX = "StarMinesLog";

$arg_score = -1;
$arg_name = "Unknown";
$arg_info = "-1 -1";
$arg_format = "";
$arg_limit = 25;
$arg_begin = 1;
$method = $ENV{"REQUEST_METHOD"};

if ($method eq "" ) { ## command line  testing
    $method = $ARGV[0];
    $temp = $ARGV[1];
}
else {
    $temp = "";
    ## Real CGI
    if ($method eq "GET") {
        $temp = $ENV{"QUERY_STRING"};
    }
    else { 
        read(STDIN, $temp, $ENV{"CONTENT_LENGTH"});
    }
}

@pairs=split(/&/,$temp);
foreach $item(@pairs) {
  ($key,$content)=split (/=/,$item,2);
  $key =~ s/[^A-Za-z0-9_]/_/ge;
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  ## Assign variable
  eval "\$arg_$key = '$content'";
  print STDERR "Eval '$key' error: $@\n" if ($@);
  if ( $content eq "on" ) {
    eval "\$arg_$key = 'true'";
  }
}

if ($arg_method eq "POST") {
    $method = "POST"; # Since old applet JVMs cannot POST, fake it with GET!
}
if ($arg_format eq "") {
    print "Content-type: text/plain\n\n";
}
else {
    print "Content-type: text/html\n\n";
}
if ($arg_name eq "") {
    $arg_name="Nobody";
}
# print "temp=$temp, name=$arg_name, score=$arg_score, info=$arg_info\n";

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$mon++;
$year+=1900;
$log = "$GAMEPATH/$LOGPREFIX"."-$year-$mon.txt";

if ($arg_format eq "") {    ## Log only non-HTML requests (from applet)
    open(FILE, ">>$log") or die "Cannot append to $log";
    printf (FILE "%02d.%02d.%02d\t%02d:%02d:%02d\t%s\t%s\t%s\t%s", 
        $year, $mon, $mday, $hour, $min, $sec,
        $method, $ENV{"REMOTE_ADDR"}, $arg_name, $arg_score);
    if ($method eq "POST") {
        printf(FILE "\t%s\n", $arg_info);
    }
    else {
        printf(FILE "\t%s\n", $ENV{"HTTP_USER_AGENT"});
    }
    close(FILE);
}

$replace = 0;
$lines = 0;
# File must exist and have at least one entry
if (!open(FILE, "$GAMEPATH/$SCORES")) {
    die "Cannot open $GAMEPATH/$SCORES";
}
$nameSeen = 0;
$inserted = 0;
while(<FILE>) {
  chop;
  ($fScore, $fName, $fInfo) = split(/\t/,$_,3);
  if (!$nameSeen && $arg_score > $fScore) {
    $line[$replace] = "$arg_score\t$arg_name\t$arg_info";
    $replace++; $lines++;
    $arg_score = -1;
    $inserted = 1;
  } 
  if ($fName eq $arg_name) {
    $nameSeen = 1;
    $arg_score = -1;
    if (!$inserted) {
      $line[$replace] = $_;
      $replace++; $lines++;
    }
  }
  else {
    $line[$replace] = $_;
    $replace++; $lines++;
  }
}
if ($arg_score > 0) {
    $line[$replace] = "$arg_score\t$arg_name\t$arg_info";
    $lines++;
}

close(FILE);

if ($method eq "POST") {
    open(FILE, ">$GAMEPATH/$SCORES.$$");
    for ($i = 0; $i < $lines; $i++) {
      print (FILE "$line[$i]\n");
    }
    close(FILE);
    ### Keep backup for each day, also try to minimize concurrency problems
    unlink("$GAMEPATH/$SCORES.$wday");
    rename("$GAMEPATH/$SCORES", "$GAMEPATH/$SCORES.$wday");
    rename("$GAMEPATH/$SCORES.$$", "$GAMEPATH/$SCORES");
}

if ($arg_format eq "") {
  for ($i = 0; $i < $lines && $i < $arg_limit; $i++) {
    print "$line[$i]\n";
  }
}
else {
  print '<html><head><title>StarMines for Java - Hall of Fame</title></head>';
  print '<body text="yellow" link="white" vlink="yellow" bgcolor="black">';
  print "<center><h2>StarMines for Java - Hall of Fame</h2>\n";
  print '<table border=1 cellspacing="1" cellpadding="1" width="400" >';
  print '<tr><td width="10%" align=center>#</td>';
  print '<td width="35%" align=center>Player</td>';
  print '<td width="25%" align=center>Score</td>';
  print '<td width="10%" align=center>Level</td>';
  print '<td width="20%" align=center>Bonusoids';
  print "\n</td></tr>";
  $| = 1;
  for ($i = $arg_begin; $i < $lines+1 && $i-$arg_begin < $arg_limit; $i++) {
    ($fScore, $fName, $fInfo) = split(/\t/,$line[$i-1],3);
    ($level, $zoids) = split(/ /,$fInfo,2);
    if ($level eq "") {
        $level = "&nbsp;";
        $zoids = "&nbsp;";
    }
    print "<tr><td align=center>".($i).".</td>";
    print "<td align=center>&nbsp;$fName</td>";
    print "<td align=center>$fScore</td>";
    print "<td align=center>$level</td>";
    print "<td align=center>$zoids</td>";
    print "</tr>\n";
  }
  print '</table>';
  if ($arg_begin+$arg_limit-1 < $lines) {
      print '<p><a href="smjscores.pl?format=html&limit='.$arg_limit;
      print '&begin='.($arg_begin+$arg_limit).'">[Next page]</a>';
  }
  print '<p><a href="monthscores.pl?format=html">[This month\'s top 25]</a>';
  print '<p><a href="StarMines.html">[Back to Game]</a>';

  print "</center></body>\n</html>\n";
}

